<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="项目名称" prop="projectId">
        <el-select v-model="queryParams.projectId" filterable  placeholder="请选择项目" clearable @change="doQuerySub">
          <el-option v-for="(item, index) in projectOptions" :key="index" :label="item.projectName" :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="总包单位" prop="subDeptId">
        <el-select v-model="queryParams.subDeptId" filterable placeholder="请选择总包单位" clearable>
          <el-option v-for="(item, index) in depts" :key="index" :label="item.deptName" :value="item.deptId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['project:attendanceConfig:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['project:attendanceConfig:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['project:attendanceConfig:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5" v-if="1 == 2">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['project:attendanceConfig:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="attendanceConfigList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="对接厂商" align="center" prop="vendorName" />
      <el-table-column label="项目名称" align="center" prop="projectName" />
      <el-table-column label="总包单位" align="center" prop="unitName" />
      <el-table-column label="是否启用" align="center" prop="enabled">
        <template slot-scope="{row}">
          <el-switch v-model="row.enabled" :active-value="1" @change="doUpdateRow(row)" :inactive-value="0"></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['project:attendanceConfig:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['project:attendanceConfig:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />


    <config-dialog ref="cfgDlg" @success="getList"></config-dialog>
  </div>
</template>

<script>
import { listAttendanceConfig, getAttendanceConfig, delAttendanceConfig, addAttendanceConfig, updateAttendanceConfig } from "@/api/project/attendanceConfig";
import configDialog from './attendanceConfigDialog.vue'
export default {
  components: { configDialog },
  name: "AttendanceConfig",
  dicts: ['attendance_vendors'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 项目考勤配置表格数据
      attendanceConfigList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        projectId: null,
        subDeptId: null,
        vendorsCode: null,
        vendorsParameter: null,
        enabled: null,
        state: null,
        isDel: null,
      },
      // 表单参数
      form: {
        projectId: '',
        subDeptId: '',
        appId: '',
        secret: '',
        appProjectId: '',
        enabled: 0
      },
      // 表单校验
      rules: {

      },
      projectOptions: [],
      depts: [],
      formDepts: [],
      actTab: '',
      mode: '',
    };
  },
  created() {
    this.getList();
    this.init();
  },
  methods: {
    doQuerySub() {
      let prjId=this.queryParams.projectId;      
      let tmps = this.prjDept2 && this.prjDept2[prjId] ? this.prjDept2[prjId] || [] : [];
      if (tmps.length > 0 || !prjId) {
        this.depts = tmps;
        if (tmps.length == 1) {
          this.queryParams.subDeptId = tmps[0].deptId;
        } else {
          this.queryParams.subDeptId = '';
        }
        return;
      }
      this.$api.publics.queryUnitList({
        projectId: prjId,
        unitTypes: "2".split(","),
      }).then((d) => {
        let objs = d.rows || [];
        if (!this.prjDept2) {
          this.prjDept2 = {};
        }
        this.prjDept2[prjId] = objs;
        this.depts = objs;
        if (objs.length == 1) {
          this.queryParams.subDeptId = objs[0].deptId;
        } else {
          this.queryParams.subDeptId = '';
        }
      });
    },
    init() {
      if (this.projectOptions && this.projectOptions.length > 0) {
        return;
      }
      this.$api.publics.getMyProjectList({}).then((response) => {
        this.projectOptions = response.rows;
      });
    },
    /** 查询项目考勤配置列表 */
    getList() {
      this.loading = true;
      listAttendanceConfig(this.queryParams).then(response => {
        this.attendanceConfigList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$refs.cfgDlg.showDialog({
        mode: 'add',
        projectOptions: this.projectOptions
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$refs.cfgDlg.showDialog({
        mode: 'edit',
        row: row,
        projectOptions: this.projectOptions
      });
    },
    doUpdateRow(row) {
      updateAttendanceConfig(row).then(response => {
        this.$modal.msgSuccess("修改成功");
        this.getList();
      });
    },

    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除项目考勤配置编号为"' + ids + '"的数据项？').then(function () {
        return delAttendanceConfig(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('project/attendanceConfig/export', {
        ...this.queryParams
      }, `attendanceConfig_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
